CON

  BUTTON_PINS   = $FF           ' The QuickStart's touch buttons are on the eight LSBs

PUB Start(delayAndBytesPtr, buttonPtr)
'' delayAndBytesPtr is the address of the long holding
'' the delay amount.  There should be nine bytes
'' imediately after the delay variable to hold
'' the pad states.  The first of the nine bytes
'' will contain the state of all eight pads
'' as a series of bits.  The remaining eight
'' bytes will contain either an one or a zero
'' depending on the state of its corresponding
'' pad.

  buttonAddress := buttonPtr
  cognew(@Entry, delayAndBytesPtr)      ' Launch a new cog to read samples            

DAT

                        org
Entry                                                                                                                                    
              rdlong    WaitTime, par
              mov       addressBase, par
              'add       addressBase, #4
              mov       outa, #BUTTON_PINS              ' set TestPins high, but keep as inputs

              mov       Wait, cnt                       ' preset the counter
              add       Wait, WaitTime
              
Loop          mov       counter, resetLoop
              mov       stickybuttons, temp
              mov       temp, zero
innerLoop     or        dira, #BUTTON_PINS              ' set TestPins as outputs (high)
              andn      dira, #BUTTON_PINS              ' set TestPins as inputs (floating)
              mov       reading, #BUTTON_PINS           ' create a mask of applicable pins
              waitcnt   wait, waitTime                  ' wait for the voltage to decay
              andn      reading, ina                    ' clear decayed pins from the mask
              or        temp, reading
              or        stickybuttons, temp
              djnz      counter, #innerLoop
              mov       addressTemp, buttonAddress 
              'wrbyte    stickybuttons, addressTemp
              'add       addressTemp, one
              mov       bitCount, #8
:Bit          shr       stickybuttons, one wc   ' shift off the bit to write
              mov       temp2, zero
              muxc      temp2, one              ' make temp2 either one or zero
              wrbyte    temp2, addressTemp
              add       addressTemp, one
              djnz      bitCount, #:Bit
              jmp       #Loop

zero          long      0
one           long      1
resetLoop     long      4
temp          long      0
counter       long      0
buttonAddress long      0
reading       res       1
waitTime      res       1
wait          res       1
stickybuttons res       1
addressBase   res       1
addressTemp   res       1
temp2         res       1
bitCount      res       1                          